using System;
using System.Collections.Generic;
using System.Text;
//using Visma.Core.Deployment.Target.Validator;
//using Visma.Core.Deployment.Target.IPC;
using System.Windows.Forms;
//using Visma.Core.Deployment.Target.Validator.Extensions;
using System.Net;
using System.IO;
using System.Linq;
using Microsoft.Deployment.WindowsInstaller;

using Visma.Services.PlatformValidator.Core;
using Visma.Services.PlatformValidator.Core.Extensions;      
  

public class CheckOtherOPG : IssueExtension
{

  const string OTHER_OPG_UPGRADE_CODE = "{09532196-633F-4478-B18F-0E5F033CF874};{82BA5C96-E0AF-42B3-BFAB-A7BAAA8A7AFD}";

   public override IssueState Detect(IssueExtensionArgument arg)
   {
      
       try
       {
            if (ExistsOtherOPGProduct())
            {
                arg.Reporter.Log(GetText("Exists"));
                return IssueState.Failed;
            }
            arg.Reporter.Log(GetText("NotExists"));
            return IssueState.Success;

       }
       catch(Exception ex)
       {
           arg.Reporter.Warn(ex.ToString());
           return IssueState.Unresolved;
       }

      //if ( arg.AllowGui )
      //{
      //   // We're allowed to show a GUI - if you do, use arg.ParentWindow as parent window
      //}
      
      //if ( arg.DoRepair )
      //{
      //   // Platform Validator wants us to repair - try to do so.
      //}

      //arg.Reporter.Log( "Hello world from Template" );
      //arg.Reporter.Warn(GetText("DemoText"));			// for localization - DemoText refers to text in Xml-file



      //// Return one of the following
      //return IssueState.NotRelevant;	// This issue is not relevant - Will not be shown in issue listy
      //return IssueState.Unresolved;	// Unable to evaluate whether the issue is a problem or not
      //return IssueState.Failed;		// The issue is a problem -  icon in list
      //return IssueState.Success;	// The issue is not a problem - green icon in list
   }
   
      public static bool ExistsOtherOPGProduct()
        {
            var otherupcodes = OTHER_OPG_UPGRADE_CODE.Split(new[] { ';' }, StringSplitOptions.RemoveEmptyEntries);

            foreach (string s in otherupcodes)
            {
                IEnumerable<ProductInstallation> allInstalledProducts = ProductInstallation.GetRelatedProducts(s);
                bool exists = false;
                foreach (ProductInstallation product in allInstalledProducts)
                {
                    exists = true;
                    break;
                }
                if (exists) return true;
            }
            return false;
        }
}
