<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
   <xsl:template match="/">
      <html>
         <head>
            <link rel="stylesheet" type="text/css" href="vpvi.css"/>
         </head>
         <body>
            <xsl:for-each select="issue">
               <h1>
                  <p align="center" >
                  <xsl:value-of select="title"/>
                  </p>
               </h1>
               <p align="center" >
                  <b>Version: </b><xsl:value-of select="version"/>
               </p>
               <p align="center">
                  <xsl:value-of select="summary"/>
               </p>
               <H2>Attributes</H2>
               <xsl:apply-templates select="category-collection"/>
               <xsl:apply-templates select="platform-collection"/>
               <xsl:apply-templates select="product-collection"/>
               <xsl:apply-templates select="description"/>
               <xsl:apply-templates select="detection"/>
               <xsl:apply-templates select="symptom-collection"/>
               <xsl:apply-templates select="resolution"/>
               <xsl:apply-templates select="reference-collection"/>
            </xsl:for-each>
         </body>
      </html>
   </xsl:template>

   <xsl:template match="description">
      <H2>Description</H2>
      <P>
         <xsl:apply-templates/>
      </P>
   </xsl:template>

   <xsl:template match="detection">
      <H2>Detection</H2>
      <P>
         <xsl:apply-templates/>
      </P>
   </xsl:template>

   <xsl:template match="resolution">
      <H2>Resolution</H2>
      <P>
         <xsl:apply-templates/>
      </P>
   </xsl:template>

   <xsl:template match="category-collection">
      <P>
         <B>
            Categories: <nbsp/>
         </B>
         <xsl:for-each select="category">
            <xsl:value-of select="."/>,<nbsp/>
         </xsl:for-each>
      </P>
   </xsl:template>

   <xsl:template match="platform-collection">
      <P>
         <B>
            Platforms: <nbsp/>
         </B>
         <xsl:for-each select="platform">
            <xsl:apply-templates/>,<nbsp/>
         </xsl:for-each>
      </P>
   </xsl:template>

   <xsl:template match="product-collection">
      <P>
         <B>
            Products: <nbsp/>
         </B>
         <xsl:for-each select="product">
            <xsl:apply-templates/>,<nbsp/>
         </xsl:for-each>
      </P>
   </xsl:template>

   <xsl:template match="symptom-collection">
      <H2>Symptoms</H2>
      <ol>
         <xsl:for-each select="symptom">
            <li>
               <xsl:value-of select="."/>
            </li>
         </xsl:for-each>
      </ol>
   </xsl:template>

   <xsl:template match="reference-collection">
      <H2>References</H2>
      <ol>
         <xsl:for-each select="reference">
            <li>
               <xsl:apply-templates/>
            </li>
         </xsl:for-each>
      </ol>
   </xsl:template>

   <xsl:template match="href">
      <a href="{@url}">
         <xsl:value-of select="@caption"/>
      </a>
   </xsl:template>
   <xsl:template match="button">
      <button onclick="window.navigate('execute://{@method}')">
         <xsl:value-of select="@caption"/>
      </button>
   </xsl:template>

   <xsl:template match="linebreakhere">
      <br/>
   </xsl:template>
</xsl:stylesheet>

